;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;								;;
;;  Rezident made by REZIDER v2					;;
;;								;;
;;  Name : Crypt 1.10		Copyright (C) 199?-1999 Pixel	;;
;;								;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; To compile (turbo assembler) enter
;;	tasm crypt.asm /m
;;	tlink crypt.obj /t
;;
;; You can change these values. Those don't even have to be primes, but I think
;; it makes a lot better hash it they are.
;;
hash_buff_size	= 1024
max_pass	= 64
prime_1023_1	= 769
prime_65535_1	= 18217
prime_65535_2	= 43133
;\
; >-------------------------------------------------------------
;/
locals @@
model tiny
.code
	org	100h
start:
	jmp	get_rezident

debug	macro	label
	db	90h
	call	label
	endm
include __8086.inc	; load compatibility module
;--------------------------------------------------------------------------
INT_21	proc	far

	cmp	ah,3Dh	;Open
	je	open
	cmp	ah,3Ch	
	je	create
	cmp	ah,6Ch	;Extended open
	je	extended_open
	cmp	ah,3Eh	;Close
	je	close
	cmp	ah,40h	;write to file
	je	write
	cmp	ah,3Fh	;read from file
	je	read
	cmp	ah,5Bh
	je	shit
return:
	db	0EAh	;far jump to original interrupt vector
ofs_21	dw	?
seg_21	dw	?
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
shit:
create:
open:	;debug	debug_open_1
	push	si
	mov	si,dx
	call	compare_si
	pop	si
extended_open_entry:
	jne	return
	pushf
	call	dword ptr cs:ofs_21
	;debug	debug_open_2
	jc	skip
	call	add_handle
skip:	retf	2
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
extended_open:
	call	compare_si
	jmp	short extended_open_entry
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
close:	call	del_handle
	jmp	return
write:	call	check_handle
	jne	return
	call	find_ofs
	mov	cs:len,cx
	push	cs:pos_h
	push	cs:pos_l
	call	encrypt
	pop	cs:pos_l
	pop	cs:pos_h
	pushf
	call	dword ptr cs:ofs_21
	call	decrypt
	retf	2
read:	call	check_handle
	jne	return
	call	find_ofs
	pushf
	call	dword ptr cs:ofs_21
	mov	cs:len,ax
	call	decrypt
	retf	2
INT_21	endp
;-------------------------------------------------------------------------------
compare_si proc near
	_pusha
	mov	di,offset truename
	push	cs
	pop	es
	mov	cx,64
	xor	ax,ax
	push	di
	rep	stosw
	pop	di
	mov	ah,60h
	pushf
	call	dword ptr cs:ofs_21
	mov	cx,10
	mov	si,offset prefix
	mov	di,offset truename
	mov	cx,cs:prefix_size
	push	si
	push	cs
	pop	ds
	rep	cmpsb
	pop	di
	_popa
	retn
compare_si endp
;-------------------------------------------------------------------------------
beep:	push ax dx
	pushf
	mov	ah,2
	mov	dl,7
	pushf
	call	dword ptr cs:ofs_21
	popf
	pop dx ax
	retn
;-------------------------------------------------------------------------------
check_handle proc near
	_pusha
	mov	cx,cs:handles
	jcxz	check_handle_empty
	mov	si,offset handle
check_handle_loop:
	segcs
	lodsw
	cmp	ax,bx
	loopne	check_handle_loop
check_handle_entry:
	_popa
	ret
check_handle_empty:
	inc	cx
	jmp	check_handle_entry
check_handle endp
;-------------------------------------------------------------------------------
del_handle proc near
	pushf
	push	cx si ax bx
	cld
	mov	cx,cs:handles
	jcxz	del_handle_skip
	mov	si,offset handle
del_handle_loop:
	segcs
	lodsw
	cmp	ax,bx
	loopnz	del_handle_loop
	jnz	del_handle_skip
	debug	debug_del
	dec	cs:handles
	jcxz	del_handle_skip
del_handle_move:
	segcs
	lodsw
	mov	cs:[si-4],ax
	loop	del_handle_move
del_handle_skip:
	pop	bx ax si cx
	popf
	ret
del_handle endp
;-------------------------------------------------------------------------------
encrypt proc near
	pushf
	_pusha
	debug	debug_encrypt
	mov	cx,cs:len
	jcxz	@@nothing
	mov	si,dx
	mov	di,dx
	push	ds
	pop	es
	cld
@@loop:	call	getkey
	lodsb
	sub	al,bl
	xor	al,dl
	add	al,bh
	xor	al,dh
	stosb
	loop	@@loop
@@nothing:
	_popa
	popf
	retn
encrypt endp
decrypt proc near
	pushf
	_pusha
	debug	debug_decrypt
	mov	cx,cs:len
	jcxz	@@nothing
	mov	si,dx
	mov	di,dx
	mov	cx,cs:len
	push	ds
	pop	es
	cld
@@loop:	call	getkey
	lodsb
	xor	al,dh
	sub	al,bh
	xor	al,dl
	add	al,bl

	stosb
	loop	@@loop
@@nothing:
	_popa
	popf
	retn
decrypt endp
;-------------------------------------------------------------------------------
getkey	proc	near
	push	cx
	push	ds

	push	cs
	pop	ds
	mov	dx,pos_h
	mov	bx,pos_l
	add	pos_l,1
	adc	pos_h,0

	sub	dx,bx		; \ h:=(h-l) xor w[0]
	xor	dx,__1		; /
	xor	bx,dx           ; \
	neg	bx              ;   l:=w[0]-(h xor l)
	add	bx,__1		; /

	xor	dx,bx           ; \
	neg	dx		;   h:=w[1]-(h xor l)
	add	dx,__2		; /
	sub	bx,dx           ; \
	xor	bx,__2		; / l:=(l-h) xor w[1]

	sub	dx,bx		; \ h:=(h-l) xor w[2]
	xor	dx,__3		; /
	xor	bx,dx           ; \
	neg	bx              ;   l:=w[2]-(h xor l)
	add	bx,__3		; /

	xor	dx,bx           ; \
	neg	dx		;   h:=w[3]-(h xor l)
	add	dx,__4		; /
	sub	bx,dx           ; \
	xor	bx,__4		; / l:=(l-h) xor w[3]

	sub	dx,bx		; \ h:=(h-l) xor w[4]
	xor	dx,__5		; /
	xor	bx,dx           ; \
	neg	bx              ;   l:=w[4]-(h xor l)
	add	bx,__5		; /

	xor	dx,bx           ; \
	neg	dx		;   h:=w[5]-(h xor l)
	add	dx,__6		; /
	sub	bx,dx           ; \
	xor	bx,__6		; / l:=(l-h) xor w[5]

	sub	dx,bx		; \ h:=(h-l) xor w[6]
	xor	dx,__7		; /
	xor	bx,dx           ; \
	neg	bx              ;   l:=w[6]-(h xor l)
	add	bx,__7		; /

	xor	dx,bx           ; \
	neg	dx		;   h:=w[7]-(h xor l)
	add	dx,__8		; /
	sub	bx,dx           ; \
	xor	bx,__8		; / l:=(l-h) xor w[7]

	pop	ds
	pop	cx
	retn
getkey	endp
;-------------------------------------------------------------------------------
find_ofs proc near
	pushf
	_pusha
	mov	ax,4201h
	xor	dx,dx
	xor	cx,cx
	pushf
	call	dword ptr cs:ofs_21
	mov	cs:pos_l,ax
	mov	cs:pos_h,dx
	_popa
	popf
	ret
find_ofs endp
;-------------------------------------------------------------------------------
add_handle proc near
	pushf
	debug	debug_add
	push	di
	xchg	bx,ax
	call	del_handle
	xchg	bx,ax
	mov	di,cs:handles
	shl	di,1
	mov	cs:handle[di],ax
	inc	cs:handles
	pop	di
	popf
	ret
add_handle endp
;-------------------------------------------------------------------------------
prefix:	db	128 dup (?)
prefix_size	dw	?
truename db	128 dup (?)
handles  dw	0
handle   dw	50 dup (?)
pos_l	dw	?
pos_h	dw	?
len	dw	?
__1     dw	'--'
__2     dw	'--'
__3	dw	'--'
__4	dw	'--'
__5	dw	'--'
__6	dw	'--'
__7	dw	'--'
__8	dw	'--'
vseg	dw	0B800h
rezident:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;  test routines  ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
__d_write	proc near
	_pusha
	push	cs
	pop	ds
	mov	es,vseg
	mov	ah,1Bh
	mov	di,pos
	db	0B0h		; mov al,xx
@@loop:	stosw
	lodsb
	or	al,al
	jnz	@@loop
	mov	pos,di
	_popa
	ret
__d_write	endp
;-------------------------------------------------------------------------------
__d_handles	proc	near
	_pusha
	push	cs
	pop	ds
	mov	es,vseg
	mov	si,offset handles
	mov	di,pos
	lodsw
	xchg	cx,ax
	jcxz	@@q
@@1:	lodsw
	xchg	bx,ax
	call	@@e
	dec	cx
	jcxz	@@q
	mov	ax,1B00h+','
	stosw
	jmp	short @@1
@@q:	mov	pos,di
	_popa
	ret
__d_hex:
@@e:	push	cx
	mov	cx,4
	mov	ah,01Bh
@@loop:	rol	bx,1
	rol	bx,1
	rol	bx,1
	rol	bx,1
	mov	al,bl
	and	al,0Fh
	add	al,'0'
	cmp	al,'0'+10
	jb	@@tmp
	add	al,'A'-'0'-10
@@tmp:	stosw
	loop	@@loop
	pop	cx
	retn
__d_handles	endp
__d_ofs		proc	near
	_pusha
	mov	bx,ds
	push	cs
	pop	ds
	mov	es,vseg
	mov	di,pos
	call	__d_hex
	mov	ax,1B00h+':'
	stosw
	mov	bx,dx
	call	__d_hex
	mov	ax,1B00h+' '
	stosw
	mov	bx,len
	call	__d_hex
	mov	pos,di
	_popa
	ret
__d_ofs		endp
__d_pos	proc
	_pusha
	mov	bx,pos_h
	push	cs
	pop	ds
	mov	es,vseg
	mov	di,pos
	mov	ax,1B00h+'__'
	stosw
	stosw
	mov	bx,pos_h
	call	__d_hex
	mov	bx,pos_l
	call	__d_hex
	mov	bx,__1
	call	__d_hex
	mov	bx,__2
	call	__d_hex
	mov	bx,__3
	call	__d_hex
	mov	bx,__4
	call	__d_hex
	mov	bx,__5
	call	__d_hex
	mov	bx,__6
	call	__d_hex
	mov	bx,__7
	call	__d_hex
	mov	bx,__8
	call	__d_hex
	mov	pos,di
	_popa
	ret
__d_pos endp
;-------------------------------------------------------------------------------
debug_open_1	proc	near
	_pusha
	_popa
	ret
debug_open_1	endp
;-------------------------------------------------------------------------------
debug_open_2	proc near
	_pusha
	_popa
	ret
debug_open_2	endp
;-------------------------------------------------------------------------------
debug_encrypt	proc	near
	_pusha
	call	debug_init
	call	__d_handles
	mov	si,offset __d_encrypt
	call	__d_write
	call	__d_ofs
	call	__d_pos
	mov	ah,0
	int	16h
	call	debug_done
	_popa
	ret
debug_encrypt	endp
;-------------------------------------------------------------------------------
debug_decrypt	proc	near
	_pusha
	call	debug_init
	call	__d_handles
	mov	si,offset __d_decrypt
	call	__d_write
	call	__d_ofs
	call	__d_pos
	mov	ah,0
	int	16h
	call	debug_done
	_popa
	ret
debug_decrypt	endp
;-------------------------------------------------------------------------------
debug_add	proc	near
	_pusha
	call	debug_init
	call	__d_handles
	mov	si,offset __d_add
	call	__d_write
	mov	ah,0
	int	16h
	call	debug_done
	_popa
	ret
debug_add	endp
;-------------------------------------------------------------------------------
debug_del	proc	near
	_pusha
	call	debug_init
	call	__d_handles
	mov	si,offset __d_del
	call	__d_write
	mov	ah,0
	int	16h
	call	debug_done
	_popa
	ret
debug_del	endp
;-------------------------------------------------------------------------------
debug_init	proc	near
	_pusha
	push	cs
	pop	es
	mov	di,offset line
	mov	ds,cs:vseg
	xor	si,si
	mov	cx,80
	rep	movsw
	mov	ax,720h
	mov	cx,80
	xor	di,di
	mov	cs:pos,di
	push	ds
	pop	es
	rep	stosw
	_popa
	ret
debug_init	endp
debug_done	proc	near
	_pusha
	push	cs
	pop	ds
	mov	si,offset line
	mov	es,cs:vseg
	xor	di,di
	mov	cx,80
	rep	movsw
	_popa
	ret
debug_done	endp
__d_encrypt	db	' Test : encrypting',0
__d_decrypt	db	' Test : Decrypting',0
__d_add		db	' Test : adding handle',0
__d_del		db	' Test : deleting handle',0
pos	dw	?
line	dw	80 dup (?)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
rezident_debug:
get_rezident:
	mov	ah,9
	mov	dx,offset intro
	int	21h
	cld
	mov	ax,3521h
	int	21h	; Get original vector of INT 21
	mov	seg_21,es
 	cmp	bx,offset INT_21
 	jne	not_yet
 	mov	al,ds:[bx]
 	cmp	al,es:[bx]
 	jne	not_yet
	jmp	uninstall
not_yet:
	mov	ofs_21,bx
	push	cs
	pop	es

	mov	si,81h
	mov	di,offset prefix
	xor	cx,cx
loop_1:	lodsb
	cmp	al,''
	jne	not_debug_1
	or	debuging,1
	jmp	short loop_1
not_debug_1:
	cmp	al,' '
	je	loop_1
	cmp	al,9
	je	loop_1
	cmp	al,13
	je	lab_1
	cmp	al,10
	jne	lab_2
lab_1:	mov	ah,9
	mov	dx,offset par_err
	int	21h
	int	20h
lab_2:	cmp	al,'a'
	jb	lab_3
	cmp	al,'z'
	ja	lab_3
	add	al,'A'-'a'
lab_3:	stosb
	inc	cx
	lodsb
	cmp	al,' '
	je	lab_4
	cmp	al,9
	je	lab_4
	cmp	al,13
	je	lab_4
	cmp	al,10
	jne	lab_2
lab_4:	mov	prefix_size,cx
;---------------------------------------------------------------------------
;
; Read password
;
	mov	ah,9
	mov	dx,offset get_password
	int	21h

	mov	dx,offset input_buffer
	call	get_string
	mov	di,dx
	add	dl,[di+1]
	adc	dh,0
	inc	dx
	inc	dx
	mov	di,dx
	mov	cx,0+max_pass
	mov	al,0
	rep	stosb

	cmp	pass_length,0
	jne	password_ok
	mov	ah,9
	mov	dx,offset password_err
	int	21h
	int	20h
password_ok:
;---------------------------------------------------------------------------
;
; Hash
;

	call	hash_init
	call	hash

;	mov	cl,hash_buff[prime_1023_1]
;	mov	ch,0
;	inc	cx
;loop_hash:
;	call	hash
;	loop	loop_hash

	mov	si,offset hash_buff
	mov	di,offset __1
	mov	cx,8
	rep	movsw

;---------------------------------------------------------------------------
	mov	ax,2521h
	mov	dx,offset INT_21
	int	21h
	mov	ah,9
	mov	dx,offset install_text
	int	21h
	mov	dx,offset rezident
	test	debuging,0FFh
	jz	skip_debug_install
	mov	dx,offset rezident_debug
	push	dx
	mov	ah,9
	mov	dx,offset debug_text
	int	21h
	pop	dx
skip_debug_install:
	cmp	debuging,1
	je	do_not_clear
	mov	si,100h		; clear all debug calls
	lodsb
	mov	cx,rezident-start
clearing_loop:
	mov	ah,al
	lodsb
	cmp	ax,90E8h
	jne	debug_call_not_found
	mov	al,ah
	mov	ds:[si],ax
	mov	ds:[si-1],al
	setalc				; al=0 or FF  (never 90 :)
debug_call_not_found:
	loop	clearing_loop
do_not_clear:
	int	27h		; Terminate but stay resident
uninstall:
	mov	ax,2521h
	lds	dx,dword ptr es:ofs_21
	int	21h

	mov	ah,49h		; release program memory
	int	21h
	mov	es,es:[2Ch]	; release environment
	mov	ah,49h
	int	21h
	push	cs
	pop	ds
	mov	ah,9
	mov	dx,offset uninstall_text
	int	21h
	int	20h
;---------------------------------------------------------------------------
get_string proc near
	push	dx di si ax cx

	mov	di,dx
	xor	cx,cx
	mov	ch,[di]
	inc	di
	inc	di
@@loop:	mov	ah,0
	int	16h
	cmp	al,0
	je	@@loop
	cmp	ax,011Bh	; ESC
	je	@@quit
	cmp	ax,1C0Dh	; Enter
	je	@@end
	cmp	ax,0E08h	; Backspace
	je	@@baxpace
	cmp	ch,cl
	je	@@loop
	stosb
	inc	cx
	mov	ah,2
	push	dx
	mov	dl,''
	int	21h
	pop	dx
	jmp	@@loop
@@baxpace:
	or	cl,cl
	jz	@@loop
	dec	cx
	mov	ah,9
	push	dx
	mov	dx,offset @@bax
	int	21h
	pop	dx
	dec	di
	jmp	@@loop
@@end:	mov	di,dx
	inc	di
	mov	al,cl
	stosb
	mov	ah,2
	mov	dl,13
	int	21h
	mov	ah,2
	mov	dl,10
	int	21h
	pop	cx ax si di dx
	ret
@@bax	db	8,' ',8,'$'
@@quit:	int 20h
get_string endp
;---------------------------------------------------------------------------
hash_init	proc	near

	xor	dx,dx
	mov	si,offset password
	mov	di,offset hash_buff
	mov	dl,[si]
	xor	bx,bx
	inc	dx
	mov	dh,dl
	mov	cx,hash_buff_size
@@loop:
	movsb
;       lodsb
;	add	ax,si
;	stosb
	dec	dl
	jnz	@@no_need
	mov	dl,dh
	mov	si,offset password;
@@no_need:
	loop	@@loop

	ret
hash_init	endp
;---------------------------------------------------------------------------
hash	proc	near
	mov	di,offset hash_buff
	mov	cx,hash_buff_size
	mov	dx,prime_65535_1
	mov	si,prime_65535_2

@@loop:	xor	ax,ax
	mov	al,[di]
	add	ax,dx
	xor	dx,dx
	div	si
	mov	al,dl
	stosb
	loop	@@loop

	ret
hash	endp
;---------------------------------------------------------------------------

debuging	db	0
debug_text	db	' test debuging -ON-',13,10,'$'
install_text	db	'File encryptor insatlled',13,10,'$'
uninstall_text	db	'File encryptor uninsatlled',13,10,'$'
get_password	db	'Enter password',13,10,'>$'
intro		db	'Crypt 1.10 (C) 199?-1999 Pixel',0Dh,0Ah,'$'
par_err		db	'usage : crypt path',13,10,'$'
password_err	db	"I'd like some password :))",13,10,'sorry foolish mortal :)',13,10,'$'
input_buffer	db	max_pass
pass_length	db	0
password	db	max_pass dup (0)

		db	200 dup (?)
hash_buff	db	1024 dup (?)

end	start